﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mLbl As Label
	Private pnlBG As Panel
	Private lvInstList As ListView
	Private pnlBorder As Panel
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Act As Activity,Seqr As MidiSequencer,Left As Int,Top As Int,Width As Int,Height As Int)
	
	Act.LoadLayout("InstList")
	pnlBorder.SetLayout(Left,Top,Width,Height)
	lvInstList.SetLayout(2Dip,2Dip,pnlBorder.Width - 4,pnlBorder.Height - 4)
	
	lvInstList.SingleLineLayout.Label.Height = 25Dip
	lvInstList.SingleLineLayout.Label.TextSize = 20
	
	Dim TempList As List
	TempList.Initialize
	
	For Each key As String In MidiGeneralMidi_Static.GetDrumNames
		TempList.Add(key)
	Next
	
	TempList.Sort(True)
	For Each key As String In TempList
		lvInstList.AddSingleLine2(key,MidiGeneralMidi_Static.GetDrumNoteNum(key))
	Next
End Sub
'Set
Private Sub lvInstList_ItemClick (Position As Int, Value As Object)
	mLbl.Text = MidiGeneralMidi_Static.GetDrumName(Value)
	Dim P As Panel = mLbl.Tag
	Dim TD As TrackData = P.Tag
	'Update the note number for new events
	TD.NoteNum = Value
	'Change the Stored Instrument name
	TD.InstName = mLbl.Text
	'Change the note number for each event in the track
	For Each MEvt As MidiEvent In TD.Track.EventList
		Dim MMsg As MidiMessage = MEvt.Message
		If MMsg.IsMetaMessage Then
			If MMsg.MetaType = MidiMessage_Static.META_SEQ_OR_TRACK_NAME Then
				MMsg.setMetaMessage(MidiMessage_Static.META_SEQ_OR_TRACK_NAME, TD.InstName.GetBytes("UTF-8"), TD.InstName.Length)
			End If
		Else
			If MMsg.IsShortMessage AND _
			(MMsg.ShortMessageCommand = MidiMessage_Static.STATUS_NOTE_OFF OR MMsg.ShortMessageCommand = MidiMessage_Static.STATUS_NOTE_ON OR MMsg.ShortMessageCommand = MidiMessage_Static.STATUS_POLY_PRESSURE)  Then
				MMsg.Message(1) = Value
			End If
		End If
	Next
	Hide
	CallSub(Main,"CheckCurrentState")
End Sub
'Show the instrument list
Sub Show(Lbl As Label)
	mLbl = Lbl
	pnlBG.Visible = True
	pnlBG.BringToFront
End Sub
'Hide the instrument list
Sub Hide
	pnlBG.Visible = False
End Sub
'Returns the current visibility of the Instrument List
Sub Visible As Boolean
	Return pnlBG.Visible
End Sub
Sub PnlBG_Click
	Hide
End Sub