﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
#RaisesSynchronousEvents:
Sub Class_Globals

	Private mPnl As Panel
	Private mSeqr As MidiSequencer
	Private mTD As TrackData
	Private lblTrackName As Label
	Private ISVol As InputSlider
	Private tbSolo As ToggleButton
	Private tbMute As ToggleButton
	Private lblSolo As Label
	Private lblMute As Label
	Private mMixer As TrackMixer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Act As Activity,Mixer As TrackMixer,Pnl As Panel,Seqr As MidiSequencer,TD As TrackData) As Panel

	mPnl = Pnl
	mTD = TD
	mSeqr = Seqr
	mMixer = Mixer
	
	mPnl.LoadLayout("MixerTrack")
	lblTrackName.Text = TD.InstName
	lblTrackName.TextSize = Main.LblTextSize

	ISVol.Initialize(Me,"ISVol")
	ISVol.Setup(Act,mPnl,(mPnl.Width - 30Dip) / 2,40Dip,30Dip,mPnl.Height-40Dip)
	ISVol.VerticalHiLo = True
	ISVol.Max = 127
	'Set the slider to the current Note volume for the track
	ISVol.Value = TD.NoteVolume
	
	tbSolo.Checked = TD.Solo
	tbMute.Checked = TD.Mute

	If lblTrackName.Text = "Master" Then
		lblSolo.Visible = False
		lblMute.Visible = False
		tbSolo.Visible = False
		tbMute.Visible = False
		
	End If
	Return mPnl
End Sub
Private Sub ISVol_ValueChanged(Value As Double,UserChanged As Boolean)
	If UserChanged Then
		If lblTrackName.Text = "Master" Then
			'Send a global volume control message for the channel
			For Each R As MidiReceiver In mSeqr.Receivers
				R.SendRealTimeMessage(Array As Byte(0xB9,0x07,Value))
			Next
			mMixer.MasterVolume = Value
		Else
			'We cannot control the output volume for different notes in a midi track at a global level, so we need to change the velocity for each note.
			For Each Evt As MidiEvent In mTD.Track.EventList
				Dim MMsg As MidiMessage = Evt.Message
				Dim Msg() As Byte = MMsg.Message
				'Only for note on events
				If Bit.AND(Msg(0),0xF0) = MidiMessage_Static.STATUS_NOTE_ON Then Msg(2) = Value
			Next
			mTD.NoteVolume = Value
		End If
	End If
End Sub
Private Sub tbSolo_CheckedChange(Checked As Boolean)
	Dim TrackNo As Int = mSeqr.GetSequence.GetTracksList.IndexOf(mTD.Track)
	mSeqr.setTrackSolo(TrackNo,Checked)
	mTD.Solo = Checked
End Sub
Private Sub tbMute_CheckedChange(Checked As Boolean)
	Dim TrackNo As Int = mSeqr.GetSequence.GetTracksList.IndexOf(mTD.Track)
	mSeqr.setTrackMute(TrackNo,Checked)
	mTD.Mute = Checked
End Sub